/***************************************************************************

Copyright (c) Microsoft Corporation. All rights reserved.
This code is licensed under the Visual Studio SDK license terms.
THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.

This code is a part of the Visual Studio Library.

***************************************************************************/

#ifndef IPERSISTSTORAGE_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
#define IPERSISTSTORAGE_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5

#if _MSC_VER > 1000
#pragma once
#endif

#include "ObjIdl.h"

#pragma warning(push)
#pragma warning(disable : 4510) // default constructor could not be generated
#pragma warning(disable : 4610) // can never be instantiated - user defined constructor required
#pragma warning(disable : 4512) // assignment operator could not be generated
#pragma warning(disable : 6011) // Dereferencing NULL pointer (a NULL derference is just another kind of failure for a unit test

namespace VSL
{

class IPersistStorageNotImpl :
	public IPersistStorage
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IPersistStorageNotImpl)

public:

	typedef IPersistStorage Interface;

	STDMETHOD(IsDirty)()VSL_STDMETHOD_NOTIMPL

	STDMETHOD(InitNew)(
		/*[in,unique]*/ IStorage* /*pStg*/)VSL_STDMETHOD_NOTIMPL

	STDMETHOD(Load)(
		/*[in,unique]*/ IStorage* /*pStg*/)VSL_STDMETHOD_NOTIMPL

	STDMETHOD(Save)(
		/*[in,unique]*/ IStorage* /*pStgSave*/,
		/*[in]*/ BOOL /*fSameAsLoad*/)VSL_STDMETHOD_NOTIMPL

	STDMETHOD(SaveCompleted)(
		/*[in,unique]*/ IStorage* /*pStgNew*/)VSL_STDMETHOD_NOTIMPL

	STDMETHOD(HandsOffStorage)()VSL_STDMETHOD_NOTIMPL

	STDMETHOD(GetClassID)(
		/*[out]*/ CLSID* /*pClassID*/)VSL_STDMETHOD_NOTIMPL
};

class IPersistStorageMockImpl :
	public IPersistStorage,
	public MockBase
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IPersistStorageMockImpl)

public:

VSL_DEFINE_MOCK_CLASS_TYPDEFS(IPersistStorageMockImpl)

	typedef IPersistStorage Interface;
	struct IsDirtyValidValues
	{
		HRESULT retValue;
	};

	STDMETHOD(IsDirty)()
	{
		VSL_DEFINE_MOCK_METHOD_NOARGS(IsDirty)

		VSL_RETURN_VALIDVALUES();
	}
	struct InitNewValidValues
	{
		/*[in,unique]*/ IStorage* pStg;
		HRESULT retValue;
	};

	STDMETHOD(InitNew)(
		/*[in,unique]*/ IStorage* pStg)
	{
		VSL_DEFINE_MOCK_METHOD(InitNew)

		VSL_CHECK_VALIDVALUE_INTERFACEPOINTER(pStg);

		VSL_RETURN_VALIDVALUES();
	}
	struct LoadValidValues
	{
		/*[in,unique]*/ IStorage* pStg;
		HRESULT retValue;
	};

	STDMETHOD(Load)(
		/*[in,unique]*/ IStorage* pStg)
	{
		VSL_DEFINE_MOCK_METHOD(Load)

		VSL_CHECK_VALIDVALUE_INTERFACEPOINTER(pStg);

		VSL_RETURN_VALIDVALUES();
	}
	struct SaveValidValues
	{
		/*[in,unique]*/ IStorage* pStgSave;
		/*[in]*/ BOOL fSameAsLoad;
		HRESULT retValue;
	};

	STDMETHOD(Save)(
		/*[in,unique]*/ IStorage* pStgSave,
		/*[in]*/ BOOL fSameAsLoad)
	{
		VSL_DEFINE_MOCK_METHOD(Save)

		VSL_CHECK_VALIDVALUE_INTERFACEPOINTER(pStgSave);

		VSL_CHECK_VALIDVALUE(fSameAsLoad);

		VSL_RETURN_VALIDVALUES();
	}
	struct SaveCompletedValidValues
	{
		/*[in,unique]*/ IStorage* pStgNew;
		HRESULT retValue;
	};

	STDMETHOD(SaveCompleted)(
		/*[in,unique]*/ IStorage* pStgNew)
	{
		VSL_DEFINE_MOCK_METHOD(SaveCompleted)

		VSL_CHECK_VALIDVALUE_INTERFACEPOINTER(pStgNew);

		VSL_RETURN_VALIDVALUES();
	}
	struct HandsOffStorageValidValues
	{
		HRESULT retValue;
	};

	STDMETHOD(HandsOffStorage)()
	{
		VSL_DEFINE_MOCK_METHOD_NOARGS(HandsOffStorage)

		VSL_RETURN_VALIDVALUES();
	}
	struct GetClassIDValidValues
	{
		/*[out]*/ CLSID* pClassID;
		HRESULT retValue;
	};

	STDMETHOD(GetClassID)(
		/*[out]*/ CLSID* pClassID)
	{
		VSL_DEFINE_MOCK_METHOD(GetClassID)

		VSL_SET_VALIDVALUE(pClassID);

		VSL_RETURN_VALIDVALUES();
	}
};


} // namespace VSL

#pragma warning(pop)

#endif // IPERSISTSTORAGE_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
