/***************************************************************************

Copyright (c) Microsoft Corporation. All rights reserved.
This code is licensed under the Visual Studio SDK license terms.
THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.

This code is a part of the Visual Studio Library.

***************************************************************************/

#ifndef IVSCOLORIZER2_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
#define IVSCOLORIZER2_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5

#if _MSC_VER > 1000
#pragma once
#endif

#include "textmgr2.h"

#pragma warning(push)
#pragma warning(disable : 4510) // default constructor could not be generated
#pragma warning(disable : 4610) // can never be instantiated - user defined constructor required
#pragma warning(disable : 4512) // assignment operator could not be generated
#pragma warning(disable : 6011) // Dereferencing NULL pointer (a NULL derference is just another kind of failure for a unit test

namespace VSL
{

class IVsColorizer2NotImpl :
	public IVsColorizer2
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IVsColorizer2NotImpl)

public:

	typedef IVsColorizer2 Interface;

	STDMETHOD(BeginColorization)()VSL_STDMETHOD_NOTIMPL

	STDMETHOD(EndColorization)()VSL_STDMETHOD_NOTIMPL
};

class IVsColorizer2MockImpl :
	public IVsColorizer2,
	public MockBase
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IVsColorizer2MockImpl)

public:

VSL_DEFINE_MOCK_CLASS_TYPDEFS(IVsColorizer2MockImpl)

	typedef IVsColorizer2 Interface;
	struct BeginColorizationValidValues
	{
		HRESULT retValue;
	};

	STDMETHOD(BeginColorization)()
	{
		VSL_DEFINE_MOCK_METHOD_NOARGS(BeginColorization)

		VSL_RETURN_VALIDVALUES();
	}
	struct EndColorizationValidValues
	{
		HRESULT retValue;
	};

	STDMETHOD(EndColorization)()
	{
		VSL_DEFINE_MOCK_METHOD_NOARGS(EndColorization)

		VSL_RETURN_VALIDVALUES();
	}
};


} // namespace VSL

#pragma warning(pop)

#endif // IVSCOLORIZER2_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
