/***************************************************************************

Copyright (c) Microsoft Corporation. All rights reserved.
This code is licensed under the Visual Studio SDK license terms.
THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.

This code is a part of the Visual Studio Library.

***************************************************************************/

#ifndef IVSCOMMANDWINDOWCOMPLETION_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
#define IVSCOMMANDWINDOWCOMPLETION_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5

#if _MSC_VER > 1000
#pragma once
#endif

#include "completion.h"

#pragma warning(push)
#pragma warning(disable : 4510) // default constructor could not be generated
#pragma warning(disable : 4610) // can never be instantiated - user defined constructor required
#pragma warning(disable : 4512) // assignment operator could not be generated
#pragma warning(disable : 6011) // Dereferencing NULL pointer (a NULL derference is just another kind of failure for a unit test

namespace VSL
{

class IVsCommandWindowCompletionNotImpl :
	public IVsCommandWindowCompletion
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IVsCommandWindowCompletionNotImpl)

public:

	typedef IVsCommandWindowCompletion Interface;

	STDMETHOD(SetCompletionContext)(
		/*[in]*/ LPCOLESTR /*pszFilePath*/,
		/*[in]*/ IVsTextLines* /*pBuffer*/,
		/*[in]*/ const TextSpan* /*ptsCurStatement*/,
		/*[in]*/ IUnknown* /*punkContext*/)VSL_STDMETHOD_NOTIMPL
};

class IVsCommandWindowCompletionMockImpl :
	public IVsCommandWindowCompletion,
	public MockBase
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IVsCommandWindowCompletionMockImpl)

public:

VSL_DEFINE_MOCK_CLASS_TYPDEFS(IVsCommandWindowCompletionMockImpl)

	typedef IVsCommandWindowCompletion Interface;
	struct SetCompletionContextValidValues
	{
		/*[in]*/ LPCOLESTR pszFilePath;
		/*[in]*/ IVsTextLines* pBuffer;
		/*[in]*/ TextSpan* ptsCurStatement;
		/*[in]*/ IUnknown* punkContext;
		HRESULT retValue;
	};

	STDMETHOD(SetCompletionContext)(
		/*[in]*/ LPCOLESTR pszFilePath,
		/*[in]*/ IVsTextLines* pBuffer,
		/*[in]*/ const TextSpan* ptsCurStatement,
		/*[in]*/ IUnknown* punkContext)
	{
		VSL_DEFINE_MOCK_METHOD(SetCompletionContext)

		VSL_CHECK_VALIDVALUE_STRINGW(pszFilePath);

		VSL_CHECK_VALIDVALUE_INTERFACEPOINTER(pBuffer);

		VSL_CHECK_VALIDVALUE_POINTER(ptsCurStatement);

		VSL_CHECK_VALIDVALUE_INTERFACEPOINTER(punkContext);

		VSL_RETURN_VALIDVALUES();
	}
};


} // namespace VSL

#pragma warning(pop)

#endif // IVSCOMMANDWINDOWCOMPLETION_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
