/***************************************************************************

Copyright (c) Microsoft Corporation. All rights reserved.
This code is licensed under the Visual Studio SDK license terms.
THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.

This code is a part of the Visual Studio Library.

***************************************************************************/

#ifndef IVSUSERDATA_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
#define IVSUSERDATA_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5

#if _MSC_VER > 1000
#pragma once
#endif

#include "textmgr.h"

#pragma warning(push)
#pragma warning(disable : 4510) // default constructor could not be generated
#pragma warning(disable : 4610) // can never be instantiated - user defined constructor required
#pragma warning(disable : 4512) // assignment operator could not be generated
#pragma warning(disable : 6011) // Dereferencing NULL pointer (a NULL derference is just another kind of failure for a unit test

namespace VSL
{

class IVsUserDataNotImpl :
	public IVsUserData
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IVsUserDataNotImpl)

public:

	typedef IVsUserData Interface;

	STDMETHOD(GetData)(
		/*[in]*/ REFGUID /*riidKey*/,
		/*[out]*/ VARIANT* /*pvtData*/)VSL_STDMETHOD_NOTIMPL

	STDMETHOD(SetData)(
		/*[in]*/ REFGUID /*riidKey*/,
		/*[in]*/ VARIANT /*vtData*/)VSL_STDMETHOD_NOTIMPL
};

class IVsUserDataMockImpl :
	public IVsUserData,
	public MockBase
{

VSL_DECLARE_NONINSTANTIABLE_BASE_CLASS(IVsUserDataMockImpl)

public:

VSL_DEFINE_MOCK_CLASS_TYPDEFS(IVsUserDataMockImpl)

	typedef IVsUserData Interface;
	struct GetDataValidValues
	{
		/*[in]*/ REFGUID riidKey;
		/*[out]*/ VARIANT* pvtData;
		HRESULT retValue;
	};

	STDMETHOD(GetData)(
		/*[in]*/ REFGUID riidKey,
		/*[out]*/ VARIANT* pvtData)
	{
		VSL_DEFINE_MOCK_METHOD(GetData)

		VSL_CHECK_VALIDVALUE(riidKey);

		VSL_SET_VALIDVALUE_VARIANT(pvtData);

		VSL_RETURN_VALIDVALUES();
	}
	struct SetDataValidValues
	{
		/*[in]*/ REFGUID riidKey;
		/*[in]*/ VARIANT vtData;
		HRESULT retValue;
	};

	STDMETHOD(SetData)(
		/*[in]*/ REFGUID riidKey,
		/*[in]*/ VARIANT vtData)
	{
		VSL_DEFINE_MOCK_METHOD(SetData)

		VSL_CHECK_VALIDVALUE(riidKey);

		VSL_CHECK_VALIDVALUE(vtData);

		VSL_RETURN_VALIDVALUES();
	}
};


} // namespace VSL

#pragma warning(pop)

#endif // IVSUSERDATA_H_10C49CA1_2F46_11D3_A504_00C04F5E0BA5
